// ================================================== //
//           Contact Center interface utils           //
//                     Version 2.2.5                  //
//                                                    //
// ---------- (c) AO SBK 2015-2022 ---------- //
// ================================================== //

var urlParams;
(window.onpopstate = function () {
  var match,
  pl = /\+/g,  // Regex for replacing addition symbol with a space
  search = /([^&=]+)=?([^&]*)/g,
  decode = function (s) { return decodeURIComponent(s.replace(pl, " ")); },
  query = window.location.search.substring(1);
  urlParams = {};
  while (match = search.exec(query)) {
    if(urlParams[decode(match[1])]) {
      if(typeof(urlParams[decode(match[1])]) != 'object') {
        var tmp = urlParams[decode(match[1])];
        urlParams[decode(match[1])] = [];
        urlParams[decode(match[1])].push(tmp);
      }
      urlParams[decode(match[1])].push(decode(match[2]));
    } else {
      urlParams[decode(match[1])] = decode(match[2]);
    }
  }
})();

var $window = $(window);
var windowHeight = $window.height();
$window.on('resize',function(){
  windowHeight = $window.height();
  $('.content').css('min-height', windowHeight - $('.header').outerHeight(true) - $('.footer').outerHeight(true) - $('body').outerHeight(true) + $('body').height());
  $('.scrollList, .jspScrollable, .jspContainer, .jspPane').each(function() {
    var corr = $(this).hasClass('jspPane') ? -14 : 0;
    if(corr) {
      $(this).width($(this).parent().width() + corr);
    }
  });
  $('.onethirdwidth.stickList').removeAttr('style').removeClass('stickList').css('width', $('.pbxFiles').width()).addClass('stickList');
  $('#defaultSettings > .marg20 > ul').css('min-height', $('#defaultSettings > .marg20 > ul > li:first-child').height());
  if($window.width() < 1200) {
    $('.header .user').hide();
  } else {
    $('.header .user').show();
  }
});

window.onbeforeunload  = function() {closeSession();}
window.onunload        = function() {closeSession();}
window.onclose         = function() {closeSession();}

function updateInterface() {
  $('#str_login').text(translate('login'));
  $('#str_pass').text(translate('pass'));
  $('#enter').text(translate('enter'));
  $('#str_monitor').text(translate('monitor'));
  $('#str_stats').text(translate('statistics'));
  $('#str_chatcenter').text(translate('chatcenter'));
  $('#logout').attr('title', translate('logout'));
  $('#str_settings').text(translate('settings'));
  $('#tQueues').text(translate('queues'));
  $('#tUsers').text(translate('domainusers'));
  $('#tIvr').text(translate('ivrmenu'));
  $('#tPstn').text(translate('pstn'));
  $('#tDescription').text(translate('description'));
  $('#str_genset_domdef').text(translate('generalSettings') + ' (' + translate('domainDefaults') + ')');
  $('#str_geninstr').text(translate('generalinstruction'));
  $('#str_qlist').text(translate('queuesList'));
  $('#str_qlistinstr').text(translate('queuelistinstruction'));
  $('#str_qname').text(translate('queuename'));
  $('#str_qext').text(translate('queueextension'));
  $('#str_agents').text(translate('agents'));
  $('#create_queue').text(translate('create') + ' ' + translate('queue'));
  $('#str_mq').text(translate('queue'));
  $('#str_mops').text(translate('operators'));
  $('#str_mb').text(translate('Busy'));
  $('#str_mav').text(translate('available'));
  $('#str_mready').text(translate('readyForIn'));
  $('#str_munav').text(translate('unavailable'));
  $('#str_mql').text(translate('queuelength'));
  $('#str_mm').text(translate('Missed'));
  $('#str_camp').text(translate('campaign'));
  $('#statusGraphsTab').text(translate('graphst'));
  $('#callsGraphsTab').text(translate('Calls'));
  $('#timelineGraphsTab').text(translate('timeline'));
  $('#str_statsfrom').text(translate('statsfrom') + ' ');
  $('#str_statsto').text(translate('statsto'));
  $('#str_req').text(translate('request'));
  $('#stats').text(translate('graphs'));
  $('#str_0h').text('0 ' + translate('hours'));
  $('#str_24h').text('24 ' + translate('hours_'));
  $('#str_filt').text(translate('filters'));
  $('#filter-queueName').val(translate('queue'));
  $('#filter-queueName').attr('data-value', translate('queue'));
  $('#filter-from').val(translate('operatorid'));
  $('#filter-from').attr('data-value', translate('operatorid'));
  $('#filter-to').val(translate('callid'));
  $('#filter-to').attr('data-value', translate('callid'));
  $('#str_sall').text(translate('all'));
  $('#str_sansw').text(translate('Answered'));
  $('#str_sunansw').text(translate('Unanswered'));
  $('#str_smiss').text(translate('Missed'));
  $('#str_stransf').text(translate('Transferred'));
  $('#str_soa').text(translate('outanswered'));
  $('#str_sof').text(translate('outfailed'));
  $('#str_thdate').text(translate('date'));
  $('#str_thtime').text(translate('time'));
  $('#str_thq').text(translate('queue'));
  $('#str_thql').text(translate('queuelength'));
  $('#str_thopid').text(translate('operatorid'));
  $('#str_thcld').text(translate('callid'));
  $('#str_thtmws').html(translate('timewait') + '<br />' + '(' + translate('seconds') + ')');
  $('#str_thtmas').html(translate('timealert') + '<br />' + '(' + translate('seconds') + ')');
  $('#str_thtmcs').html(translate('timeconnect') + '<br />' + '(' + translate('seconds') + ')');
  $('#str_thst').text(translate('statuscall'));
  $('#str_threc').text(translate('record'));
  $('#str_graphinc').text(translate('incoming'));
  $('#str_graphout').text(translate('outgoing'));
  $('#str_graphql').text(translate('queuelength'));
  $('#str_graphtw').text(translate('timewait'));
  $('#str_apon').text(translate(['agentStatus','on']));
  $('#str_apoff').text(translate(['agentStatus','off']));
  $('#str_apbreak').text(translate(['agentStatus','break']));
  /*
  $('.selfStatus').siblings('.box').find('li[data-value="on"]').text(translate(['agentStatus','on']));
  $('.selfStatus').siblings('.box').find('li[data-value="off"]').text(translate(['agentStatus','off']));
  $('.selfStatus').siblings('.box').find('li[data-value="break"]').text(translate(['agentStatus','break']));
  */
  $('#agentPanel .selfStatus').html('').siblings('.box,.value').remove();
  var statusInfo = translate('agentStatusInfo');
  if(typeof(statusInfo) != 'object') statusInfo = {};
  var statusKeys = Object.keys(translate('agentStatus'));
  var iKey;
  for(var i = 0; i < statusKeys.length; ++i) {
    iKey = statusKeys[i];
    if(iKey == 'acw') continue;
    if(statusInfo[iKey]) {
      var infoKeys = Object.keys(statusInfo[iKey]);
      var jKey;
      for(var j = 0; j < infoKeys.length; ++j) {
        jKey = infoKeys[j];
        $('#agentPanel .selfStatus').append(
            '<option value="' + iKey + '" data-value="' + jKey + '">' + statusInfo[iKey][jKey] + '</option>');
      }
    }
    $('#agentPanel .selfStatus').append('<option value="' + iKey + '">' + translate(['agentStatus', iKey]) + '</option>');
  }
  select_html($('#agentPanel .select'), true);
  $('#str_apcalls').text(translate('Calls'));
  $('#str_moncalls').text(translate('Calls'));
  $('#call').text(translate('call'));
  $('#str_apatt').text(translate('attended'));
  $('#str_aconf').text(translate('conference'));
  $('#str_atransf').text(translate('transfer'));
  $('#str_amute').text(translate('mute'));
  $('#str_ahold').text(translate('hold'));
  $('#str_ahangup').text(translate('hangup'));
  $('#str_expst').text(translate('expst'));
  $('#str_expex').text(translate('expex'));
  $('#str_expgr').text(translate('expgr'));
  $('#stopCC').text(translate('stopCC'));
  // <cg-card>
  //$('#str_sc_ag').text(translate('agents'));
  $('#str_cg_search').text(translate('search'));
  $('#str_cg_num').text(translate('number'));
  $('#str_cg_name').text(translate('name'));
  $('#str_cg_email').text(translate('email'));
  $('#req_card').text(translate('request'));
  $('#new_search').text(translate('newsearch'));
  $('.fn').parent().siblings('td:first-child').text(translate('fn'));
  $('.ln').parent().siblings('td:first-child').text(translate('ln'));
  $('.title').parent().siblings('td:first-child').text(translate('title'));
  $('.org').parent().siblings('td:first-child').text(translate('org'));
  $('.add_tel').text(translate('addphone')).parent().siblings('td:first-child').text(translate('phone'));
  $('.add_email').text(translate('addemail')).parent().siblings('td:first-child').text(translate('email'));
  $('.street').parent().siblings('td:first-child').text(translate('street'));
  $('.city').parent().siblings('td:first-child').text(translate('city'));
  $('.state').parent().siblings('td:first-child').text(translate('state'));
  $('.pc').parent().siblings('td:first-child').text(translate('pc'));
  $('.country').parent().siblings('td:first-child').text(translate('country'));
  $('.web').parent().siblings('td:first-child').text(translate('website'));
  $('.card_description').parent().siblings('td:first-child').text(translate('description'));
  $('.upd_cgc').text(translate('update'));
  $('#new_cgc').text(translate('createnew'));
  $('#str_sc_scr').text(translate('scripts'));
  $('#show_search').text(translate('search'));
  $('#str_history').text(translate('history'));
  $('#q_cgc').text(translate('close'));
  // </cg-card>
  $('#str_callback_btn').text(translate('callback'));
  $('#str_amsg').text(translate('message'));
  $('#reconnecting').text(translate('reconnecting'));
  $('.lang option[value="default"]').text(translate('default'));
  $('.lang').siblings('.box').find('li[data-value="default"]').text(translate('default'));
  if($('.lang').val() == 'default') {
    $('.lang').siblings('.value').text(translate('default'));
  }
  $('#filter-intext option').eq(0).text(translate('all'));
  $('#filter-intext option').eq(1).text(translate('internal'));
  $('#filter-intext option').eq(2).text(translate('external'));
  $('#filter-intext').siblings('.value').text($('#filter-intext option:selected').text());
  $('#filter-intext').siblings('.box').find('li').eq(0).text(translate('all'));
  $('#filter-intext').siblings('.box').find('li').eq(1).text(translate('internal'));
  $('#filter-intext').siblings('.box').find('li').eq(2).text(translate('external'));
  // <monAgentFilter>
  $('#str_sc_ag select').html('').siblings().remove();
  var cafs = $('#str_sc_ag select');
  cafs.append('<option value="" selected="selected">' + translate('allagents') + '</option>');
  for(var i = 0; i < statusKeys.length; ++i) {
    iKey = statusKeys[i];
    if(iKey == 'acw') continue;
    if(statusInfo[iKey]) {
      var infoKeys = Object.keys(statusInfo[iKey]);
      var jKey;
      for(var j = 0; j < infoKeys.length; ++j) {
        jKey = infoKeys[j];
        cafs.append('<option value="' + jKey + '">' + statusInfo[iKey][jKey] + '</option>');
      }
    }
    cafs.append('<option value="' + iKey + '">' + translate(['agentStatus', iKey]) + '</option>');
  }
  cafs.off('change');
  cafs.on('change', function() {
    var c = $('#cg_agents');
    var agents = Object.keys(monitorData.agent);
    var iKey;
    if(this.value) {
      for(var i = 0; i < agents.length; ++i) {
        iKey = agents[i]; var iAgent = monitorData.agent[iKey];
        if((iAgent.status == this.value && iAgent.statusInfo == null) || iAgent.statusInfo == this.value) {
          c.find('div[data-value="' + iKey + '"]').parent().parent().show();
        } else {
          c.find('div[data-value="' + iKey + '"]').parent().parent().hide();
        }
      }
    } else {
      for(var i = 0; i < agents.length; ++i) {
        iKey = agents[i];
        c.find('div[data-value="' + iKey + '"]').parent().parent().show();
      }
    }
    $(this).siblings('.box').hide();
  });
  select_html(cafs.parent());
  // </monAgentFilter>
}

$window.ready(function() {
  /*
  if($.cookie('rus')) {
    $('.lang').removeClass('eng');
  }
  if($('.lang').hasClass('eng')) {
    getStrings();
  } else {
    getStrings('russian');
  }
  $('.lang').on('click',function() {
    var t = $(this);
    if(t.hasClass('eng')) {
      t.removeClass('eng');
      $.cookie('rus', 1);
      getStrings('russian');
    } else {
      t.addClass('eng');
      $.removeCookie('rus');
      getStrings();
    }
  });
  */
  //$('.lang').val(lang);
  getStrings(lang);
  $('.ilang').val(lang);
  select_html($('.lang').parent());
  $('.lang').on('change',function() {
    if(this.value == 'default') {
      getStrings(lang);
      return;
    }
    lang = this.value;
    getStrings(this.value);
    $('.ilang').val(this.value);
  });
  $('.ilang').on('change', function() {
    lang = this.value;
    $(this).siblings('.description').text($(this).find('option[value="' + this.value + '"]').text());
    $('.lang').val(this.value);
    getStrings(this.value);
    var un = userName;
    var sid = sessionId;
    langFlag = true;
    hideInterface();
    loginContactCenter(un, sid, true, true);
  });
  select_html($('#ilang'));
  $('#ilang .value').removeClass('value').removeClass('bg').addClass('description').addClass('pointer');
  $('#ilang .box').css('color', '#FFF').css('left', '-33px');
  $('#enter').on('click', function(e) {
    e.preventDefault();
    loginContactCenter($('#login').val(), $('#pass').val());
  });
  if(urlParams.username && urlParams.sid) {
    loginContactCenter(urlParams.username, urlParams.sid, true);
    $('.footer').hide();
  }
  if(urlParams.username && urlParams.password) {
    passwd = urlParams.password;
    loginContactCenter(urlParams.username, urlParams.password);
  }
  $('#logout').on('click',function() {
    logoutContactCenter();
  });
  // <agentPanel>
  $('#str_apcalls').on('click', function() {
    $('#selfQueue').toggleClass('woqt');
    $(this).toggleClass('grey');
  });
  $('#agentPanel .selfStatus').html('');
  var statusInfo = translate('agentStatusInfo');
  if(typeof(statusInfo) != 'object') statusInfo = {};
  var statusKeys = Object.keys(translate('agentStatus'));
  var iKey;
  for(var i = 0; i < statusKeys.length; ++i) {
    iKey = statusKeys[i];
    if(iKey == 'acw') continue;
    if(statusInfo[iKey]) {
      var infoKeys = Object.keys(statusInfo[iKey]);
      var jKey;
      for(var j = 0; j < infoKeys.length; ++j) {
        jKey = infoKeys[j];
        $('#agentPanel .selfStatus').append(
            '<option value="' + iKey + '" data-value="' + jKey + '">' + statusInfo[iKey][jKey] + '</option>');
      }
    }
    $('#agentPanel .selfStatus').append('<option value="' + iKey + '">' + translate(['agentStatus', iKey]) + '</option>');
  }
  select_html($('#agentPanel .select'), true);
  $('#agentPanel .selfStatus').on('change', function() {
    setAgentStatus(sessionParams.name, $(this).val(), $(this).attr('data-value'));
  });
  $('#actions .action').on('click', function() {
    if(!$('#selfMonitor a').length && this.id != 'amsg' && this.id != 'aconf') {
      return;
    }
    var peerID = $('#selfMonitor a:first-child').attr('data-value');
    var callID;
    if(peerID) {
      callID = getCallByPeer(peerID);
    } else {
      callID = $('#selfMonitor span:first-child').attr('data-value');
    }
    if(this.id == 'ahangup') {
      $(this).toggleClass('ff0').parent().siblings('td').children('.ff0').removeClass('ff0');
      $('#cld').css('visibility', 'hidden');
      $('#cld input').val('');
      var p = refer || onservice || callID;
      $('#card .closeIcon').trigger('click');
      hangUp(p);
      var that = this;
      setTimeout(function() {
        $(that).removeClass('ff0');
      }, 500);
    } else if(this.id == 'atransf'){
      $(this).toggleClass('ff0');
      if($(this).hasClass('ff0')) {
        //$('#cld').css('visibility', 'visible');
        //$('#cld input').trigger('focus');
        if(!$('#ahold').hasClass('ff0')) {
          setHold(callID);
        }
        displayCrmCard(peerID, 'transfer');
      } else {
        //$('#cld').css('visibility', 'hidden');
        //$('#cld input').val('');
        setHold(callID);
        $('#card .closeIcon').trigger('click');
      }
    } else if(this.id == 'aconf') {
      $(this).toggleClass('ff0');
      if($(this).hasClass('ff0')) {
        displayCrmCard(peerID, 'conf');
      } else {
        $('#card .closeIcon').trigger('click');
      }
    } else if(this.id == 'ahold') {
      if($(this).hasClass('ff0')) {
        $('#card .closeIcon').trigger('click');
      }
      setHold(callID);
    } else if(this.id == 'amute') {
      var mode = 'on';
      if($(this).hasClass('ff0')) {
        mode = 'off';
      }
      setMute(callID, mode);
    } else if(this.id == 'amsg') {
      $(this).toggleClass('ff0');
      if($(this).hasClass('ff0')) {
        displaySMSForm(callID);
      } else {
        $('#sms_form').remove();
      }
    }
  });
  /*
  $('#cld button').on('click', function() {
    var action = $('#actions .ff0').attr('id');
    if(action == 'atransf') {
      var to = $('#cld input').val();
      var callID = getFirstLineCall(sessionParams.name);
      var peerID = getMyPeerId(callID);
      if(callID && to) {
        makeAttendedTransfer(callID, peerID, to);
      }
    }
    $('#actions .ff0').trigger('click');
  });
  */
  // </agentPanel>
  $('#iFrameLink').on('click', function() {
    if(sessionParams.iFrameUrl) $('#tabCard iframe').toggle();
  });
  $('.header .menu li').on('click',function() {
    if($(this).hasClass('logo')) {
      if(!sessionParams.access.admin.length) {
        return;
      }
      $('.tabActive').removeClass('tabActive');
      $('#tabSettings').addClass('tabActive');
      $('#iFrameLink').hide();
      $('#card .closeIcon').trigger('click');
    } else if($(this).hasClass('monitor')) {
      $('.tabActive').removeClass('tabActive');
      $('#tabMonitors').addClass('tabActive');
      $('#iFrameLink').hide();
      if(!$('#callGroup').hasClass('active')) {
        $('#callGroup .head').trigger('click');
      }
    } else if($(this).hasClass('card')) {
      $('.tabActive').removeClass('tabActive');
      $('#tabCard').addClass('tabActive');
      //if($('#scenario .table_tab .agn').hasClass('bg2')) {
      //  if(cga_jsp) {
      //    cga_jsp.destroy();
      //  }
      //  cga_jsp = $('#cg_agents .scrollList').jScrollPane({contentWidth: '0px'}).data().jsp;
      //}
      //if($('#scenario .table_tab .scr').hasClass('bg2')) {
      //  if(cgs_jsp) {
      //    cgs_jsp.destroy();
      //  }
      //  cgs_jsp = $('#scripting .scrollList').jScrollPane({contentWidth: '0px'}).data().jsp;
      //}
      if(isArrElem(sessionParams.name, agents)) {
        $('#iFrameLink').css('display', 'inline');
      }
    } else if($(this).hasClass('statistics')) {
      $('.tabActive').removeClass('tabActive');
      $('#tabStatistics').addClass('tabActive');
      $('#iFrameLink').hide();
      $('#card .closeIcon').trigger('click');
    } else if($(this).hasClass('chatcenter')) {
      if(!sessionParams.access.admin.length) {
        return;
      }
      tabChat();
      $('.tabActive').removeClass('tabActive');
      $('#tabChat').addClass('tabActive');
      $('#iFrameLink').hide();
      $('#card .closeIcon').trigger('click');
    }
    $window.trigger('resize');
    $('.header .menu .bg').removeClass('bg');
    $(this).addClass('bg');
    $('.scriptList').remove();
    $('#callbackButton').hide();
    $('#ivrLog .closeIcon').trigger('click');
    $('#prefilterSettings .closeIcon').trigger('click');
  });
  $('#scenario .table_tab li').on('click', function() {
    var t = $(this);
    if(t.hasClass('bg2')) return false;
    if(t.hasClass('agn')) {
      $('#cg_agents').show().siblings().hide();
    } else if(t.hasClass('scr')) {
      $('#scripting').show().siblings().hide();
      script_list = [];
      getScriptList();
    }
    setTimeout(function() {$('.header .menu li.card').trigger('click')}, 50);
    t.addClass('bg2').siblings('.bg2').removeClass('bg2');
  });
  $('#cg_card .table_tab li').on('click', function() {
    var t = $(this);
    if(t.hasClass('bg2')) return false;
    //$('#cgc').hide().siblings('#cgh').hide().siblings('.loader').show();
    if(t.hasClass('cgc')) {
      $('#cgc').show().siblings().hide();
    } else if(t.hasClass('cgh')) {
      if(!$('#cgc_found .card_uid').val() && !$('#cgc_form .card_uid').val()) {
        $('#cgc').show().siblings().hide();
        return false;
      }
      $('#cgh').show().siblings().hide();
      getCGHistory();
    }
    //setTimeout(function() {$('.header .menu li.card').trigger('click');}, 100);
    t.addClass('bg2').siblings('.bg2').removeClass('bg2');
  });
  $('#tabSettings .table_tab li').on('click',function() {
    var t = $(this);
    if(t.hasClass('bg2')) return false;
    var tn = this.id.substring(1);
    if(tn == 'Users') {
      if(sessionParams.isDomainAdmin) listUsers();
      else return;
    }
    if(tn == 'Queues') {
      $('.queueSettings').remove();
      $('.agentSettings').remove();
      $('.smsTemplateSettings').remove();
      $('.agentList').remove();
      $('.queueList').remove();
      $('.smsTemplatesList').remove();
      if(sessionParams.access.admin.indexOf('anyOne') >= 0) {
        getSettings('general');
      }
      if(sessionParams.access.admin.length) {
        getGroups();
      }
    }
    if(tn == 'Pstn') {
      $('.pstnSettings').remove();
      if(sessionParams.isDomainAdmin) listUsersPstn();
      else return;
    }
    if(tn == 'Ivr') {
      $('.ivrSettings').remove();
      $('.pbxFiles').remove();
      if(sessionParams.isDomainAdmin) {
        listIvr();
      } else return;
    }
    if(tn == 'Description') {
      if(!sessionParams.isDomainAdmin) {
        return;
      } else {
        $('#tabDescription').load(filesRef + translate('descriptionpage') + ' #description',
          function() {
            $('#versionnum').html(translate('versionnum'));
          }
        );
      }
    }
    t.addClass('bg2').siblings('.bg2').removeClass('bg2');
    $('#tab' + tn).addClass('active').siblings('.active').removeClass('active');
    $('.scriptList').remove();
  });
  $('#callbackButton').on('click', function() {
    var num = $('#cb_num').attr('data-value');
    if(!num) {
      $(this).hide();
      return;
    }
    makeCall(sessionParams.name, num);
    $('#cb_num').attr('data-value', '');
    $('#cb_num').text('');
    $(this).hide();
  });
  setCallMonHandlers();
});

function loginContactCenter(login, pass, sessionIDMethod, killOld) {
  createOverlay();
  createSession(domainName, location.port, login, pass, sessionIDMethod, killOld);
}
function logoutContactCenter() {
  createOverlay();
  closeSession();
}

function resetVars() {
  myController = null;
  sessionId = null;
  userName = null;
  passwd = null;
  meetingName = '';
  taskRef = null;
  sessionParams = null;
  resetMonitorData();
  directoryData = [];
  cardData = {};
  groups = [];
  agents = [];
  statistics = {};
  timeframe = {
	  firstDate: '',
  	secondDate: '',
  	firstHour: 0,
  	secondHour: 24
  };
  recordDefault = null;
  generalPstn = {};
  ivrTable = {};
  onservice = null;
  refer = null;
  mute = null;
  card = null;
}

function checkAccountLanguage() {
  if($('.lang').val() != 'default') return;
  getPrefs();
}

function createOverlay() {
  $('<div class="overlay"></div>').appendTo("body").height($(document).height());
  $('<div class="loader"></div>').appendTo("body").css({ 'position' : 'fixed' });
}

function closeOverlay() {
	$('body > .loader').remove();
	$('body > .overlay').remove();
}

function showInterface() {
  if(!passwd && $('#pass').val()) passwd = $('#pass').val();
  $('#pass').val('');
  $('.login').hide();
  $('.footer').hide();
  $('.loginFooter').removeClass('loginFooter');
  $('.header').show();
  if(sessionParams.access.admin.length) {
    $('.header .menu li.logo').trigger('click');
    //$('.header .menu li.monitor').show();
  } else {
    //$('.header .menu li.monitor').hide();
    $('.header .menu li.card').trigger('click');
  }
  if(sessionParams.isDomainAdmin) {
    //$('.header .menu li.monitor').show();
    $('#defaultSettings').css('visibility', 'visible');
    if(!$('#str_camp').length) {
      $('#str_mql').after('<li id="str_camp">' + translate('campaign') + '</li>');
    }
    // <ccupdate>
    //checkUpdates(updateurl);
    // </ccupdate>
  } else {
    $('#defaultSettings').css('visibility', 'hidden');
    $('#stopCC').hide();
    $('#stopCC').off('click');
    $('#callMon').hide();
  }
  if(sessionParams.ccHiddenModules) {
    for(var i = 0; i < sessionParams.ccHiddenModules.length; i++) {
      hideInterfaceModule(sessionParams.ccHiddenModules[i]);
    }
  }
  $('.header .user').text(userName);
	$window.trigger('resize');
}
function hideInterfaceModule(moduleName) {
  if(moduleName.indexOf('!') == 0) {
    moduleName = moduleName.substr(1);
    if(!moduleName || !module_controls[moduleName]) return;
    $(module_controls[moduleName]).trigger('click');
    return;
  }
  $(modules[moduleName]).hide();
}
function resetInterfaceModules() {
  var keys = Object.keys(modules);
  for(var i = 0; i < keys.length; ++i) {
    $(modules[keys[i]]).css('display', '');
  }
}
function compareVersion(version) {
  version = version.replace(/\s/, '');
  var lv = version.split('.');
  var cv = str.versionnum.split('.');
  for(var i = 0; i < lv.length; i++) {
    if(cv[i] == undefined || parseInt(lv[i]) > parseInt(cv[i])) {
      displayUpdatePrompt();
      break;
    }
  }
}
function displayUpdatePrompt() {
  $('body > .header').append('<a class="yellow right pointer" style="border-bottom-right-radius: 0px; border-top-left-radius: 0px; padding: 0px 5px;" id="updateCC" href="' + packageurl + '" target="_blank">' + translate('updatePrompt') + '</a>');
}
function hideInterface() {
  resetInterfaceModules();
  // <crmCard>
  $('#card .closeIcon').trigger('click');
  $('#ivrLog .closeIcon').trigger('click');
  $('#prefilterSettings .closeIcon').trigger('click');
  // </crmCard>
  $('#sms_form .closeIcon').trigger('click');
  resetVars();
  clearData();
  domainName = serverName;
  //$('#actions .ff0').removeClass('ff0');
  $('#cld').css('visibility', 'hidden');
  $('.content').removeClass('tabActive');
  $('.header').hide();
  $('.header .user').text('');
  $('.login').show();
  $('.footer').show();
  $('.footer').addClass('loginFooter');
  $('#agentPanel').hide();
  $('#iFrameLink').hide();
  $('#tabCard iframe').hide();
  $('#callbackButton').hide();
	$window.trigger('resize');
  closeOverlay();
}
function clearData() {
  $('.queueSettings').remove();
  $('.agentSettings').remove();
  $('.agentList').remove();
  $('.queueList').remove();
  $('.pstnSettings').remove();
  $('.ivrSettings').remove();
  $('.pbxFiles').remove();
  $('#statsTableTR').html('');
  $('#tabUsers').html('');
  $('#tabPstn').html('');
  $('#tabIvr').html('');
  $('#defaultSettings .detals').html('');
  $('#ccObjectsList').html('');
  $('#monContainer').html('');
  $('#cga').html('');
  updateStatisticsHead(statistics);
  $('#new_cgc').trigger('click');
  $('#updateCC').remove();
}

function select_html(select, ignoreChange) {
	var t = select.children('select');
	var c = '<span class="value bg">' + t.children(':selected').text() + '</span><div class="box"><div class="scrollpane"><ul>';
  var q = 0;
	t.children('option').each(function() {
		c += '<li data-value="' + $(this).val() + ($(this).attr('data-value') ? ':' + $(this).attr('data-value') : '') + '">' +
      $(this).text() + '</li>';
    q++;
	});
	c += '</ul></div></div>';
	t.before(c);
  if (select.hasClass('setMinWidth')) select.children('.value').css('min-width',select.outerWidth());

	select.children('.value').on('click', function(e) {
    e.stopPropagation();
		var t = $(this).parent();
		var box = t.children('.box');
		box.css('min-width',t.outerWidth());
		$('.select .box').not(box).hide().parent().removeClass('focus');
		if(box.css('display')=='none') {
			box.show().parent().addClass('focus');
      if(select.find('.agentStatus').length) {
        var s = select.find('.scrollpane');
        s.css('height', 75);
        s.css('min-width', select.outerWidth());
        s.jScrollPane();
      } else if(q > 7 && !box.find('.jspContainer').length) {
        var s = select.find('.scrollpane');
        s.css('height', 145);
        s.css('min-width', select.outerWidth());
        s.jScrollPane();
      }
    } else {
			box.hide().parent().removeClass('focus');
    }
		setClickCallback();
		return false;
	});
	select.find('li').on('click', function(e) {
		var t = $(this);
		if(!ignoreChange) t.closest('.box').siblings('.value').text(t.text());
    var s = t.closest('.box').siblings('select');
    var val = t.attr('data-value');
    if(val.indexOf(':') > 0) {
      s.val(val.substring(0, val.indexOf(':'))).attr('data-value', val.substring(val.indexOf(':') + 1)).trigger('change');
    } else {
  		s.val(t.attr('data-value')).removeAttr('data-value').trigger('change');
    }
	});
  if(!ignoreChange) {
    t.on('change', function() {
      select.find('.value').text(select.find('li[data-value="' + $(this).val() + '"]').text());
    });
  }
}

function mul_select_html(select) {
	var t = select.children('select');
	var c = '<span class="value bg">' + t.children(':selected').text() + '</span><div class="box"><div class="scrollpane"><ul>';
  var q = 0;
	t.children('option').each(function() {
		c += '<li data-value="' + $(this).val() + ($(this).attr('data-value') ? ':' + $(this).attr('data-value') : '') + '">' +
      $(this).text() + '</li>';
    q++;
	});
	c += '</ul></div></div>';
	t.before(c);
  select.find('li[data-value=""]').addClass('hl');
  if (select.hasClass('setMinWidth')) select.children('.value').css('min-width',select.outerWidth());

	select.children('.value').on('click', function(e) {
    e.stopPropagation();
		var t = $(this).parent();
		var box = t.children('.box');
		box.css('min-width',t.outerWidth());
		$('.select .box').not(box).hide().parent().removeClass('focus');
		if(box.css('display')=='none') {
			box.show().parent().addClass('focus');
      if(q > 7 && !box.find('.jspContainer').length) {
        var s = select.find('.scrollpane');
        s.css('height', 145);
        s.css('min-width', select.outerWidth());
        s.jScrollPane();
      }
    } else {
			//box.hide().parent().removeClass('focus');
    }
		setClickCallback(true);
		return false;
	});
	select.find('li').on('click', function(e) {
		var t = $(this);
    if(t.attr('data-value') == '') {
      t.parent().children('.hl').removeClass('hl');
      t.addClass('hl');
    } else {
      t.siblings('li[data-value=""]').removeClass('hl');
      t.toggleClass('hl');
    }
    var valArr = [];
    t.parent().children('.hl').each(function() {
      valArr.push($(this).attr('data-value'));
    });
    var s = t.closest('.box').siblings('select');
    if(t.attr('data-value') == '') select.find('.box').hide().parent().removeClass('focus');
    s.val(valArr).trigger('change');
	});
  t.on('change', function() {
    var valArr = $(this).val();
    var text = '';
    for(var i = 0; i < valArr.length; ++i) {
      text += select.find('li[data-value="' + valArr[i] + '"]').text();
      if(i < valArr.length - 1) text += ', ';
    }
    select.find('.value').text(text);
  });
}

function setClickCallback(mul) {
  $(document).one('click', function(e) {
    if($(e.target).closest('.jspVerticalBar').length) {
      setClickCallback(mul);
      return;
    }
    if(mul && $(e.target).closest('.box').length) {
      setClickCallback(mul);
      return;
    }
	  $('.select .box').hide().parent().removeClass('focus');
    e.stopPropagation();
	});
}

function getKeysCount(obj) {
  return Object.keys(obj).length;
}

// sep
function sep(n,s) {
	var sep = '<span class="sep first"></span><span class="sep last"></span>';
	var w_step = s.width() / n;
	n--;
	while (n>0) {
		sep += '<span class="sep" style="left:'+(w_step * n)+'px"></span>';
		n--;
	}
	s.prepend(sep);
}

function declension(num, expressions) {
  var result;
  count = num % 100;
  if (count > 4 && count < 21) 
    result = expressions['2'];
  else {
    count = count % 10;
    if (count == 1)
      result = expressions['0'];
    else if (count > 1 && count < 4)
      result = expressions['1'];
    else
      result = expressions['2'];
  }
  return result;
}

function getUserPart(str, limit) {
  var result = str.replace(/(\@[^\s]*)/, '');
  if(limit && result.length > limit) {
    result = result.substring(0, limit) + '...';
  }
  return result;
}

function translate(keyArr) {
  if(typeof(keyArr) == 'string') {
    return str[keyArr] ? str[keyArr] : keyArr;
  } else {
    if(!keyArr) return '';
    var result = str;
    for(var i = 0; i < keyArr.length; i++) {
      if(result[keyArr[i]]) {
        result = result[keyArr[i]];
      } else {
        result = keyArr[i];
      }
    }
    return result;
  }
}

function showNotify(callID) {
  if (Notification.permission !== "granted") Notification.requestPermission();
  var CID = getUserPart(monitorData.call[callID].callFrom);
  var name = getCrmName(callID);
  var email = getCrmEmail(callID);
  var url = getCrmUrl(callID);
  var notification = new Notification(
    translate('number') + ': ' + CID,
    {
      tag: callID,
      icon: filesRef + 'cc_icon.svg',
      body: translate('name') + ': ' + name + '\nE-Mail: ' + email,
    }
  );
  notification.onclick = function () {
    openClientIFrame(sessionParams.crmType, url)
  }
}

function getTruncName(str, ln) {
  if(!str) {
    return '';
  }
  if(str.length > ln) {
    return str.substring(0,ln) + '...';
  }
  return str;
}

function getQueueByExt(num) {
  var groups = Object.keys(monitorData.group);
  var queue;
  for(var i = 0; i < groups.length; ++i) {
    queue = groups[i];
    if(monitorData.group[queue].extensions.indexOf(num) >= 0) {
      return queue;
    }
  }
  return null;
}

function authIFrame(type, server, userid, passwd) {
  // <pronto>
  if(!passwd && window.parent && window.parent.document.getElementById('password')) {
    passwd = window.parent.document.getElementById('password').value;
  }
  // </pronto>
  if(!type || !server || !userid) return;
  if(type == 'osTicket') {
    $('#iFrame').attr(
      'src',
      server + '/scp/auto.php?userid=' + encodeURIComponent(userid) +
      '&passwd=' + encodeURIComponent(passwd)
    );
  } else if(type == 'SugarCRM') {
     $('#iFrame').attr(
      'src',
      'sugarcrm.wssp?Skin=ContactCenter&user_name=' + encodeURIComponent(userid) +
      '&user_password=' + encodeURIComponent(passwd) +
      '&url=' + encodeURIComponent(server)
    );
  } else if(sessionParams.iFrameUrl) {
    $('#iFrame').attr('src', sessionParams.iFrameUrl);
  }
}

function openClientIFrame(type, url) {
  if(!url) return;
  if(type == 'osTicket') {
    $('#iFrame').attr('src', url);
  } else if(type == 'SugarCRM') {
    $('#iFrame').attr('src', url);
  } else {
    window.open(url, '_blank');
    return;
  }
  $('#iFrame').show();
}

function makeCGPDict(obj) {
  var result = '{';
  var keys = Object.keys(obj);
  var iKey;
  for(var i = 0; i < keys.length; ++i) {
    iKey = keys[i];
    result += iKey + '='; 
    if(obj[iKey]) {
      if(typeof(obj[iKey]) == 'object') {
        result += makeCGPDict(obj[iKey]);
      } else {
        result += '"' + obj[iKey].toString() + '"';
      }
    } else {
      result += '#NULL#';
    }
    result += ';';
  }
  result += '}';
  return result;
}

function make_select(type, className, value, defaultValue) {
  var result = '';
  if(type == 'num') {
    for(var i = 0; i < 10; i++) {
      result += '<option value="' + i + '"' + (value == i ? ' selected="selected"' : '') + '>' + i + '</option>';
    }
  } else if(type == 'yesno') {
    result = '<option value="YES"' + (value == true ? ' selected="selected"' : '') + '>' + translate('yes') + '</option>' +
      '<option value="NO"' + (value == 'NO' ? ' selected="selected"' : '') + '>' + translate('no') + '</option>';
  } else if(type == 'yesnow') {
    result = '<span class="select"><select class="' + className + '"><option value=""' +
      (!value ? ' selected="selected"' : '') + '>-----</option><option value="YES"' +
      (value == true ? ' selected="selected"' : '') + '>' + translate('yes') + '</option>' +
      '<option value="NO"' + (value == 'NO' ? ' selected="selected"' : '') + '>' + translate('no') + '</option></select></span>';
    return result;
  } else if(type == 'sgy') {
    result = '<option value="random"' + (value == 'random' ? ' selected="selected"' : '') + '>' + translate(['ringStrDict', 'random']) + '</option><option value="serial"' + (value == 'serial' ? ' selected="selected"' : '') + '>' + translate(['ringStrDict', 'serial']) + '</option><option value="allFree"' + (value == 'allFree' ? ' selected="selected"' : '') + '>' + translate(['ringStrDict', 'allFree']) + '</option><option value="inOrder"' + (value == 'inOrder' ? ' selected="selected"' : '') + '>' + translate(['ringStrDict', 'inOrder']) + '</option><option value="fewestCalls"' + (value == 'fewestCalls' ? ' selected="selected"' : '') + '>' + translate(['ringStrDict', 'fewestCalls']) + '</option><option value="leastBusy"' + (value == 'leastBusy' ? ' selected="selected"' : '') + '>' + translate(['ringStrDict', 'leastBusy']) + '</option><option value="leastRecent"' + (value == 'leastRecent' ? ' selected="selected"' : '') + '>' + translate(['ringStrDict', 'leastRecent']) + '</option><option value="bySkill"' + (value == 'bySkill' ? ' selected="selected"' : '') + '>' + translate(['ringStrDict', 'bySkill']) + '</option>';
  } else if(type == 'ctout') {
    result = '<span class="select"><select class="' + className + '"><option value="">-----</option>';
    for(var i = 0; i < selectMenus.agentAttachedTime.length; i++) {
      result += '<option value="' + selectMenus.agentAttachedTime[i] + '">' + selectMenus.agentAttachedTime[i] + '</option>';
    }
    result += '<option value="other">' + translate('other') + '</option></select></span>';
    return result;
  } else if(type == 'btout') {
    result = '<span class="select"><select class="' + className + '"><option value="">-----</option>';
    for(var i = 0; i < selectMenus.agentBreakTime.length; i++) {
      result += '<option value="' + selectMenus.agentBreakTime[i] + '">' + selectMenus.agentBreakTime[i] + '</option>';
    }
    result += '<option value="other">' + translate('other') + '</option></select></span>';
    return result;
  } else if(type == 'qll') {
    result = '<span class="select"><select class="' + className + '"><option value="">-----</option>';
    for(var i = 0; i < selectMenus.queueLengthLimit.length; i++) {
      result += '<option value="' + selectMenus.queueLengthLimit[i] + '">' + selectMenus.queueLengthLimit[i] + '</option>';
    }
    result += '<option value="other">' + translate('other') + '</option></select></span>';
    return result;
  } else if(type == 'avunav') {
    result = '<span class="select"><select class="' + className + '">';
    var info = translate('agentStatusInfo');
    if(typeof(info) != 'object') info = {};
    var keys = Object.keys(translate('agentStatus'));
    var iKey;
    for(var i = 0; i < keys.length; ++i) {
      iKey = keys[i];
      if(iKey == 'acw') continue;
      if(info[iKey]) {
        var infoKeys = Object.keys(info[iKey]);
        var jKey;
        for(var j = 0; j < infoKeys.length; ++j) {
          jKey = infoKeys[j];
          result += '<option value="' + iKey + '"' + (value == jKey ? ' selected="selected"' : '') +
            ' data-value="' + jKey + '">' + info[iKey][jKey] + '</option>';
        }
      }
      result += '<option value="' + iKey + '"' + (value == iKey ? ' selected="selected"' : '') + '>' +
        translate(['agentStatus', iKey]) + '</option>';
    }
    result += '</select></span>';
    return result;
  } else if(type == 'st') {
    var keys = Object.keys(translate('agentStatus'));
    var iKey;
    for(var i = 0; i < keys.length; ++i) {
      iKey = keys[i];
      if(iKey == 'acw') continue;
      result += '<option value="' + iKey + '"' + (value == iKey ? ' selected="selected"' : '') + '>' +
        translate(['agentStatus', iKey]) + '</option>';
    }
    result += '<option value="last"' + (value == 'last' ? ' selected="selected"' : '') + '>' +
      translate('last') + '</option>';
    if(defaultValue === null) {
      return '<span class="select"><select class="' + className + '">' + result + '</select></span>';
    } else {
      return '<span class="select"><select class="' + className + '">' +
        '<option value=""' + (!value ? ' selected="selected"' : '') + '>' +
        translate('default') + ' (' + (defaultValue == 'last' ? translate('last') : translate(['agentStatus', defaultValue])) + ')</option>' + result + '</select></span>';
    }
  } else if(type == 'onoff') {
    result = '<span class="select"><select class="' + (className ? className : '') + '">' +
      '<option value="on"' + (value == 'on' ? ' selected="selected"' : '') + '>' +
      translate(['boolDict', 'on']) + '</option>';
    result += '<option value="off"' + (value == 'off' ? ' selected="selected"' : '') + '>' +
      translate(['boolDict', 'off']) + '</option>';
    result += '</select></span>';
    return result;
  } else if(type == 'period') {
    result =
      '<span class="select"><select data-value="' + defaultValue + '" class="' + className + '">';
    result += '<option value=""' + (value == '' || !value ? ' selected="selected"' : '') + '>' +
      translate('never') + '</option>';
    result += '<option value="2m"' + (value == '2m' ? ' selected="selected"' : '') + '>' +
      translate('minutes2') + '</option>';
    result += '<option value="3m"' + (value == '3m' ? ' selected="selected"' : '') + '>' +
      translate('minutes3') + '</option>';
    result += '<option value="5m"' + (value == '5m' ? ' selected="selected"' : '') + '>' +
      translate('minutes5') + '</option>';
    result += '<option value="10m"' + (value == '10m' ? ' selected="selected"' : '') + '>' +
      translate('minutes10') + '</option>';
    result += '<option value="15m"' + (value == '15m' ? ' selected="selected"' : '') + '>' +
      translate('minutes15') + '</option>';
    result += '<option value="20m"' + (value == '20m' ? ' selected="selected"' : '') + '>' +
      translate('minutes20') + '</option>';
    result += '<option value="30m"' + (value == '30m' ? ' selected="selected"' : '') + '>' +
      translate('minutes30') + '</option>';
    result += '<option value="1h"' + (value == '1h' ? ' selected="selected"' : '') + '>' +
      translate('hours1') + '</option>';
    result += '<option value="2h"' + (value == '2h' ? ' selected="selected"' : '') + '>' +
      translate('hours2') + '</option>';
    result += '<option value="3h"' + (value == '3h' ? ' selected="selected"' : '') + '>' +
      translate('hours3') + '</option>';
    result += '<option value="5h"' + (value == '5h' ? ' selected="selected"' : '') + '>' +
      translate('hours5') + '</option>';
    result += '<option value="6h"' + (value == '6h' ? ' selected="selected"' : '') + '>' +
      translate('hours6') + '</option>';
    result += '<option value="8h"' + (value == '8h' ? ' selected="selected"' : '') + '>' +
      translate('hours8') + '</option>';
    result += '<option value="1d"' + (value == '1d' ? ' selected="selected"' : '') + '>' +
      translate('hours24') + '</option>';
    result += '<option value="1000000000s"' + (value == '1000000000s' ? ' selected="selected"' : '') + '>' +
      translate('off') + '</option>';
    result += '</select></span>';
    return result;
  } else if(type == 'hrs' || type == 'mnts') {
    result = '<span class="select"><select class="' + className + '">';
    for(var i = 0; i < (type == 'hrs' ? 24 : 60); i++) {
      result += '<option value="' + i + '">' + (i < 10 ? '0' + i.toString() : i) + '</option>';
    }
    result += '</select></span>';
    return result;
  } else if(type == 'campListNum') {
    return '<span class="select"><select class="' + className + '">' +
      '<option value="10" selected="selected">10</option><option value="15">15</option>' +
      '<option value="20">20</option><option value="25">25</option>' +
      '<option value="50">50</option><option value="75">75</option>' +
      '<option value="100">100</option></select></span>';
  } else if(type == 'maxlinesnumber') {
    return '<span class="select"><select class="' + className + '"><option value=""' + (!value ? ' selected="selected"' : '') + '>' +
      translate('default') + ' (' + (defaultValue == 100 ? translate('unlimited') : translate(defaultValue)) + ')</option>' +
      '<option value="1"' + (value == 1 ? ' selected="selected"' : '') + '>1</option>' +
      '<option value="100"' + (value == 100 ? ' selected="selected"' : '') + '>' + translate('unlimited') + '</option>' +
      '</select></span>'
  } else if(type == 'dedtout') {
    for(var i = 1; i < 11; i++) {
      result += '<option value="' + i + '">' + i + '</option>';
    }
  } else {
    return '';
  }
  result = '<span class="select"><select class="' + className + '">' +
    '<option value=""' + (!value ? ' selected="selected"' : '') + '>' +
    translate('default') + ' (' + translate(defaultValue.toString()) + ')</option>' + result;
  result += '</select></span>';
  return result;
}

function arraysEqual(a, b) {
  if(a === b) return true;
  if(a == null || b == null) return false;
  if(a.length != b.length) return false;
  for(var i = 0; i < a.length; ++i) {
    if(a[i] !== b[i]) return false;
  }
  return true;
}

function getMyPeerId(callID) {
  if(!monitorData.call[callID]) {
    return null;
  }
  var peers = Object.keys(monitorData.call[callID].peers);
  var iKey;
  for(var i = 0; i < peers.length; ++i) {
    iKey = peers[i];
    if(monitorData.call[callID].peers[iKey].name == sessionParams.name) {
      return iKey;
    }
  }
  return null;
}

function getDayChkbxs() {
  var dnames = '';
  for(var i = 0; i < translate('daynames').length; i++) {
    dnames += translate('daynames')[i] +
      ' <input value="' + weekStandard[i] + '" checked="checked" type="checkbox" /> ';
  }
  return dnames;
}

function b64toBlob(b64Data, contentType, sliceSize) {
  contentType = contentType || '';
  sliceSize = sliceSize || 512;

  var byteCharacters = atob(b64Data);
  var byteArrays = [];

  for (var offset = 0; offset < byteCharacters.length; offset += sliceSize) {
    var slice = byteCharacters.slice(offset, offset + sliceSize);

    var byteNumbers = new Array(slice.length);
    for (var i = 0; i < slice.length; i++) {
      byteNumbers[i] = slice.charCodeAt(i);
    }

    var byteArray = new Uint8Array(byteNumbers);

    byteArrays.push(byteArray);
  }

  var blob = new Blob(byteArrays, {type: contentType});
  return blob;
}

/*!
 * jQuery Cookie Plugin v1.4.1
 * https://github.com/carhartl/jquery-cookie
 *
 * Copyright 2013 Klaus Hartl
 * Released under the MIT license
 */
(function (factory) {
  if (typeof define === 'function' && define.amd)
    define(['jquery'], factory);
  else if (typeof exports === 'object')
    factory(require('jquery'));
  else
    factory(jQuery);
}(function ($) {
  var pluses = /\+/g;
  function encode(s) {
    return config.raw ? s : encodeURIComponent(s);
  }
  function decode(s) {
    return config.raw ? s : decodeURIComponent(s);
  }
  function stringifyCookieValue(value) {
    return encode(config.json ? JSON.stringify(value) : String(value));
  }
  function parseCookieValue(s) {
    if (s.indexOf('"') === 0)
      s = s.slice(1, -1).replace(/\\"/g, '"').replace(/\\\\/g, '\\');
    try {
      s = decodeURIComponent(s.replace(pluses, ' '));
      return config.json ? JSON.parse(s) : s;
    } catch(e) {}
  }
  function read(s, converter) {
    var value = config.raw ? s : parseCookieValue(s);
    return $.isFunction(converter) ? converter(value) : value;
  }
  var config = $.cookie = function (key, value, options) {
    if (value !== undefined && !$.isFunction(value)) {
      options = $.extend({}, config.defaults, options);
      if (typeof options.expires === 'number') {
        var days = options.expires, t = options.expires = new Date();
        t.setTime(+t + days * 864e+5);
      }
      return (document.cookie = [
        encode(key), '=', stringifyCookieValue(value),
        options.expires ? '; expires=' + options.expires.toUTCString() : '',
        options.path    ? '; path=' + options.path : '',
        options.domain  ? '; domain=' + options.domain : '',
        options.secure  ? '; secure' : ''
      ].join(''));
    }
    var result = key ? undefined : {};
    var cookies = document.cookie ? document.cookie.split('; ') : [];
    for (var i = 0, l = cookies.length; i < l; i++) {
      var parts = cookies[i].split('=');
      var name = decode(parts.shift());
      var cookie = parts.join('=');
      if (key && key === name) {
        result = read(cookie, value);
        break;
      }
      if (!key && (cookie = read(cookie)) !== undefined)
        result[name] = cookie;
    }
    return result;
  };
  config.defaults = {};
  $.removeCookie = function (key, options) {
    if ($.cookie(key) === undefined)
      return false;
    $.cookie(key, '', $.extend({}, options, { expires: -1 }));
    return !$.cookie(key);
  };
}));
