// ================================================== //
//        Contact Center PSTN interface module        //
//                    Version 2.2.5                   //
//                                                    //
// ---------- (c) AO SBK 2015-2022 ---------- //
// ================================================== //

var curUserPstn = null;
var generalPstn = {};
var pstnFields = new Array('PSTNAreaCode', 'PSTNBillingPlan', 'PSTNEmergency', 'PSTNFromName', 'PSTNGatewayAuthName', 'PSTNGatewayDomain', 'PSTNGatewayPassword', 'PSTNGatewayVia', 'PSTNSMSHost');
var rsipFields = new Array('authName', 'domain', 'fromName', 'password', 'period', 'target');

function listUsersPstn() {
  $('#tabPstn').html(
    '<div class="right onethirdwidth bg standheight"><div class="marg20">' +
    '<h2>' + translate('accountlist') + ' ' + domainName + '</h2><i class="description">' +
    translate('pstnuserlistinstruction') + '</i><br /><div>' +
    '<div class="scrollList"><div id="usersPstn"><div class="loader"></div></div></div>' +
    '</div></div></div>' +
    '<div id="generalPstn" class="left twothirdwidth bg standheight">' +
    '<div class="marg20"><h2>' + translate('domainDefaults') + '</h2><i class="description">' +
    translate('generalinstruction') + '</i>' +
    '<ul><li class="left onehalfwidth detals"><div class="loader"></div>' +
    '</li><li class="left onehalfwidth detals"></li></ul></div></div>'
  );
  getUserDefaults();
  getUsers();
}

function displayUserListPstn(list) {
  var userList = $('#usersPstn');
  userList.html('');
  if(list.length) {
    var st;
    var j = 0;
    for(var i = 0; i < list.length; i++) {
      if(agents.indexOf(list[i]) >= 0) {
        st = monitorData.agent[list[i]] ? monitorData.agent[list[i]].status : 'off';
      } else {
        st = null;
      }
      if(st) icon = '<img alt="" src="' + filesRef + 'cc_agent_' + (st == 'off' ? 'off' : 'on') + '.svg" />'; else icon = '';
      userList.append(
        '<p data-value="user_' + list[i] + '" class="pointer">' +
        '<a><i>' + (j + 1) + '.</i> ' + list[i] + icon + '</a></p>'
      );
      j++;
    }
    var jspElem = userList.parent().jScrollPane();
    jspApi = jspElem.data('jsp');
    userList.find('p').on('click', function(e) {
      e.preventDefault();
      if(!$(this).attr('data-value')) return;
      if(!$(this).hasClass('bg')) {
        $(this).addClass('bg').siblings('.bg').removeClass('bg');
      }
      var userName = $(this).attr('data-value').substring(5); // 'user_'.length = 5
      var c = $('.pstnSettings');
      if(!c.length) {
        $('#tabPstn').append(
          '<div class="pstnSettings bg standheight left twothirdwidth">' +
          '<a class="closeIcon right pointer marg20" title="' + translate('close') + '"></a>' +
          '<div class="loader"></div></div>'
        );
      } else {
        c.html('<a class="closeIcon right pointer marg20" title="' + translate('close') +
          '"></a><div class="loader"></div>'
        );
      }
      $('#tabPstn .closeIcon').on('click', function() {
        $(this).parent().remove();
        userList.find('.bg').removeClass('bg');
      });
      getUserInfo(userName);
    });
    if(curUserPstn) {
      userList.find('p[data-value="user_' + curUserPstn + '"]').trigger('click');
      curUserPstn = null;
    }
    closeOverlay();
  }
}

function displayUserInfoPstn(name, pstn, rsip) {
  var c = $('.pstnSettings');
  c.html('<a class="closeIcon right pointer marg20" title="' + translate('close') + '"></a>' +
    '<div class="marg20" style="display:none"><h2 class="userName" data-value="' + name + '">' +
    translate('settingsOf') + ' ' + name + '</h2>' +
    '<ul><li class="left onehalfwidth detals">' +
    '<table id="pstn" cellspacing="5" cellpadding="0" width="100%">' +
    '<tr><td height="43" colspan="2" align="center"><h3>' + translate('pstn') + '</h3></td></tr>' +
    '<tr><td width="50%"><label>' + translate('PSTNAreaCode') + '</label></td>' +
    '<td width="50%"><input class="PSTNAreaCode bg input" type="text" size="10" /></td></tr>' +
    '<tr><td><label>' + translate('PSTNBillingPlan') + '</label></td>' +
    '<td><input class="PSTNBillingPlan bg input" type="text" size="10" /></td></tr>' +
    '<tr><td><label>' + translate('PSTNEmergency') + '</label></td>' +
    '<td><input class="PSTNEmergency bg input" type="text" size="10" /></td></tr>' +
    '<tr><td><label>' + translate('PSTNFromName') + '</label></td>' +
    '<td><input class="PSTNFromName bg input" type="text" size="10" /></td></tr>' +
    '<tr><td><label>' + translate('PSTNGatewayAuthName') + '</label></td>' +
    '<td><input class="PSTNGatewayAuthName bg input" type="text" size="10" /></td></tr>' +
    '<tr><td><label>' + translate('PSTNGatewayDomain') + '</label></td>' +
    '<td><input class="PSTNGatewayDomain bg input" type="text" size="10" /></td></tr>' +
    '<tr><td><label>' + translate('PSTNGatewayPassword') + '</label></td>' +
    '<td><input class="PSTNGatewayPassword bg input" type="password" size="10" /></td></tr>' +
    '<tr><td><label>' + translate('PSTNGatewayVia') + '</label></td>' +
    '<td><input class="PSTNGatewayVia bg input" type="text" size="10" /></td></tr>' +
    '<tr><td><label>' + translate('PSTNSMSHost') + '</label></td>' +
    '<td><input class="PSTNSMSHost bg input" type="text" size="10" /></td></tr>' +
    '</table><br /><p><button id="update_pstn" class="button ff0">' +
    translate('update') + '</button></p></li><li class="left onehalfwidth detals">' +
    '<table id="rsip" cellspacing="5" cellpadding="0" width="100%">' +
    '<tr><td height="43" colspan="2" align="center"><h3>' + translate('rsip') + '</h3></td></tr>' +
    '</table></li></ul></div>'
  );
  c.find('.closeIcon').on('click', function() {
    $(this).parent().remove();
    $('#usersPstn .bg').removeClass('bg');
  });
  for(var i = 0; i < pstnFields.length; i++) {
    c.find('.' + pstnFields[i]).val(pstn[pstnFields[i]] ? pstn[pstnFields[i]] : (generalPstn[pstnFields[i]] ? generalPstn[pstnFields[i]] : ''));
  }
  if(getKeysCount(rsip)) {
    var keys = Object.keys(rsip);
    var iKey;
    for(var i = 0; i < keys.length; ++i) {
      iKey = keys[i];
      c.find('#rsip').append(
        '<tr><td width="50%"><label>' + translate('name') + '</label></td><td width="50%">' +
        '<input class="name bg input" disabled="disabled" type="text" size="10" value="' + iKey + '" /></td></tr>'
      );
      for(var j = 0; j < rsipFields.length; j++) {
        if(rsipFields[j] == 'period') {
          c.find('#rsip').append(
            '<tr><td><label>' + translate('period') + '</label></td><td>' +
            make_select('period','period', rsip[iKey].period ? rsip[iKey].period : '',i) + '</td></tr>'
          );
          select_html(c.find('#rsip select[data-value="' + i + '"]').parent());
        } else {
          c.find('#rsip').append(
            '<tr><td><label>' + translate(rsipFields[j]) + '</label></td><td>' +
            '<input class="' + rsipFields[j] + ' bg input" type="text" size="10" data-value="' + i +
            '" value="' + (rsip[iKey][rsipFields[j]] ? rsip[iKey][rsipFields[j]] : '') + '" /></td></tr>'
          );
        }
      }
      c.find('#rsip').append('<tr><td colspan="2" align="center">-----</td></tr>');
    }
    c.find('#rsip').after('<br /><p><button id="create_rsip" class="button ff0">' +
      translate('add') + '</button></p>');
    c.find('#create_rsip').on('click', function() {
      c.find('#rsip').append(
        '<tr><td width="50%"><label>' + translate('name') + '</label></td><td width="50%">' +
        '<input class="name new bg input" type="text" size="10" /></td></tr>'
      );
      for(var j = 0; j < rsipFields.length; j++) {
        if(rsipFields[j] == 'period') {
          c.find('#rsip').append(
            '<tr><td><label>' + translate('period') + '</label></td><td>' +
            make_select('period','period','','new') + '</td></tr>'
          );
          select_html(c.find('#rsip select[data-value="new"]').parent());
        } else {
          c.find('#rsip').append(
            '<tr><td><label>' + translate(rsipFields[j]) + '</label></td><td><input class="' +
            rsipFields[j] + ' bg input" data-value="new" type="text" size="10" /></td></tr>'
          );
        }
      }
      c.find('#rsip').append('<tr><td colspan="2" align="center">-----</td></tr>');
      $(this).remove();
    });
  } else {
    c.find('#rsip').append(
      '<tr><td width="50%"><label>' + translate('name') + '</label></td><td width="50%">' +
      '<input class="name new bg input" type="text" size="10" /></td></tr>'
    );
    for(var j = 0; j < rsipFields.length; j++) {
      if(rsipFields[j] == 'period') {
        c.find('#rsip').append(
          '<tr><td><label>' + translate('period') + '</label></td><td>' +
          make_select('period','period','','new') + '</td></tr>'
        );
        select_html(c.find('#rsip select[data-value="new"]').parent());
      } else {
        c.find('#rsip').append(
          '<tr><td><label>' + translate(rsipFields[j]) + '</label></td><td>' +
          '<input class="' + rsipFields[j] + ' bg input" size="10" data-value="new" type="text" /></td></tr>'
        );
      }
    }
    c.find('#rsip').append('<tr><td colspan="2" align="center">-----</td></tr>');
  }
  c.find('#update_pstn').on('click', function() {
    var pstn = {};
    c.find('#pstn input').each(function() {
      pstn[$(this).attr('class').split(' ')[0]] =
        ($(this).val() == generalPstn[$(this).attr('class').split(' ')[0]] ? '' : $(this).val());
    });
    var rsip = {};
    c.find('#rsip .name').each(function() {
      var r = $(this).val();
      if($(this).hasClass('new')) {
        if(r) {
          rsip[r] = {};
          var isNull = true;
          c.find('#rsip input[data-value="new"]').each(function() {
            rsip[r][$(this).attr('class').split(' ')[0]] = $(this).val();
            if($(this).val()) isNull = false;
          });
          rsip[r].period = c.find('#rsip select[data-value="new"]').val();
          if(rsip[r].period) isNull = false;
        }
      } else {
        rsip[r] = {};
        var isNull = true;
        c.find('#rsip input[data-value="' + r + '"]').each(function() {
          rsip[r][$(this).attr('class').split(' ')[0]] = $(this).val();
          if($(this).val()) isNull = false;
        });
        rsip[r].period = c.find('#rsip select[data-value="' + r + '"]').val();
        if(rsip[r].period) isNull = false;
        if(isNull) delete rsip[r];
      }
    });
    if(!getKeysCount(rsip)) rsip = '';
    curUserPstn = $('.pstnSettings .userName').attr('data-value');
    updateUserRsips(curUserPstn, rsip);
    updateUserInfo(curUserPstn, pstn);
  });
  //c.css('min-height', $('#generalPstn').height());
  //c.css('top', -$('#generalPstn').height());
  c.children('div').fadeIn('slow');
  //$('#tabPstn').height(c.height());
}

function displayGeneralPstn() {
  var c = $('#generalPstn .detals:first-child');
  c.html('<table cellspacing="5" cellpadding="0" width="100%">' +
    '<tr><td height="43" colspan="2" align="center"><h3>' + translate('pstn') + '</h3></td></tr>' +
    '<tr><td width="50%"><label>' + translate('PSTNAreaCode') + '</label></td>' +
    '<td width="50%"><input class="PSTNAreaCode bg input" type="text" size="10" /></td></tr>' +
    '<tr><td><label>' + translate('PSTNBillingPlan') + '</label></td>' +
    '<td><input class="PSTNBillingPlan bg input" type="text" size="10" /></td></tr>' +
    '<tr><td><label>' + translate('PSTNEmergency') + '</label></td>' +
    '<td><input class="PSTNEmergency bg input" type="text" size="10" /></td></tr>' +
    '<tr><td><label>' + translate('PSTNFromName') + '</label></td>' +
    '<td><input class="PSTNFromName bg input" type="text" size="10" /></td></tr>' +
    '<tr><td><label>' + translate('PSTNGatewayAuthName') + '</label></td>' +
    '<td><input class="PSTNGatewayAuthName bg input" type="text" size="10" /></td></tr>' +
    '<tr><td><label>' + translate('PSTNGatewayDomain') + '</label></td>' +
    '<td><input class="PSTNGatewayDomain bg input" type="text" size="10" /></td></tr>' +
    '<tr><td><label>' + translate('PSTNGatewayPassword') + '</label></td>' +
    '<td><input class="PSTNGatewayPassword bg input" type="password" size="10" /></td></tr>' +
    '<tr><td><label>' + translate('PSTNGatewayVia') + '</label></td>' +
    '<td><input class="PSTNGatewayVia bg input" type="text" size="10" /></td></tr>' +
    '<tr><td><label>' + translate('PSTNSMSHost') + '</label></td>' +
    '<td><input class="PSTNSMSHost bg input" type="text" size="10" /></td></tr>' +
    '</table><br /><p><button id="update_general_pstn" class="button ff0">' +
    translate('update') + '</button></p>'
  );
  for(var i = 0; i < pstnFields.length; i++) {
    c.find('.' + pstnFields[i]).val(generalPstn[pstnFields[i]] ? generalPstn[pstnFields[i]] : '');
  }
  c.find('#update_general_pstn').on('click', function() {
    var params = {};
    c.find('input').each(function() {
      params[$(this).attr('class').split(' ')[0]] = $(this).val();
    });
    c.html('<div class="loader"></div>');
    updateUserDefaults(params);
  });
}

