var controller = null;
var taskRef = null;
var setName = 'mmSearch';
var searchResultLength = 10;
var programName = 'multimailboxsearch';
var defaultSearchMailbox = 'INBOX';
var openResultFlag = false;
var notify = 'incomingmailmessage';

window.onbeforeunload = function() {closeSession();}
window.onunload = function() {closeSession();}
window.onclose = function() {closeSession();}

$(document).ready(function() {
  if(urlParams.center == 'loadMailbox' || urlParams.center == '') {
    createSession(location.host, strings.userName, strings.sessionid);
    $('#searchButton').on('click', function() {
      var filter = $('#searchField').val();
      var filterField = $('#filterField').val();
      if($('#searchUnread')[0].checked) {
        filterField = 'FLAGS';
        filter = 'Unread';
      }
      if($('#searchFlagged')[0].checked) {
        filterField = 'FLAGS';
        if(filter.length) {
          filter += ',Flagged';
        } else {
          filter = 'Flagged';
        }
      }
      var mailbox = [];
      $('#searchFolderList input[type="checkbox"]').each(function() {
        if(this.checked) {
          mailbox.push(this.value);
          if(this.value == '$All') {
            return false;
          }
        }
      });
      if(!filter) {
        return;
      }
      if(!mailbox.length) {
        mailbox.push(defaultSearchMailbox);
      }
      if(taskRef) {
        closeSearch();
      }
      $('#searchField').attr('disabled', 'disabled');
      $('#searchField').trigger('focusout');
      startSearch(filter, filterField, mailbox);
    });
    $('#searchField').on('keypress', function(e) {
      if(e.keyCode == 13 && $(this).val() != $(this).attr('data-value')) {
        $('#searchButton').trigger('click');
      }
    });
    $('#stopSearch').on('click', function() {
      $('#searchIndicator').hide();
      $('#resSearchIndicator').css('visibility', 'hidden');
      $('#curSearchFolder').parent().hide();
      $('#resCurSearchFolder').parent().css('visibility', 'hidden');
      $('#searchButton').show();
      $(this).hide();
      $('#searchSettingsButton').show();
      $('#searchField').removeAttr('disabled');
      $('#searchField').trigger('focusout');
      stopSearch();
    });
    $('#foundCounter').parent().on('click', function() {
      if(!$(this).hasClass('active')) {
        return;
      }
      $('#searchResultTable').html('');
      showOverlayBlock('.searchResultBlock');
      getSearchResult(0, searchResultLength);
      $('#moreSearchResult').attr('data-value', 0);
      $('#moreSearchResult').show();
    });
    $('#moreSearchResult').on('click', function() {
      var curPos = parseInt($(this).attr('data-value'));
      getSearchResult($(this).attr('data-value'), searchResultLength);
    });
    $('.sortSearchResultDropDown .sort').on('click', function() {
      var field = $(this).attr('data-value');
      if($(this).hasClass('active')) {
        $(this).toggleClass('backward');
      }
      var dir = $(this).hasClass('backward') ? 'asc' : 'desc';
      sortSearchResult(field, dir);
      $(this).siblings().removeClass('active');
      $(this).siblings().removeClass('backward');
      $(this).addClass('active');
      $('#sortSearchButton').trigger('click');
    });
    $('#searchUnread').on('change', function() {
      if(this.checked) {
        if($('#searchFlagged')[0].checked) {
          $('#searchField').val('Unread,Flagged');
        } else {
          $('#searchField').val('Unread');
          $('#searchField').attr('disabled', 'disabled');
          $('#filterField').val('');
          $('#filterField').attr('disabled', 'disabled');
        }
      } else {
        if($('#searchFlagged')[0].checked) {
          $('#searchField').val('Flagged');
        } else {
          $('#searchField').removeAttr('disabled');
          $('#searchField').val('');
          $('#searchField').trigger('focusout');
          $('#filterField').removeAttr('disabled');
        }
      }
    });
    $('#searchFlagged').on('change', function() {
      if(this.checked) {
        if($('#searchUnread')[0].checked) {
          $('#searchField').val('Unread,Flagged');
        } else {
          $('#searchField').val('Flagged');
          $('#searchField').attr('disabled', 'disabled');
          $('#filterField').val('');
          $('#filterField').attr('disabled', 'disabled');
        }
      } else {
        if($('#searchUnread')[0].checked) {
          $('#searchField').val('Unread');
        } else {
          $('#searchField').removeAttr('disabled');
          $('#searchField').val('');
          $('#searchField').trigger('focusout');
          $('#filterField').removeAttr('disabled');
        }
      }
    });
  }
});

function prepZero(arg) {
  if(arg < 10) {
    return '0' + arg.toString();
  } else {
    return arg.toString();
  }
}

function markDefaultMailbox(list) {
  if(typeof(list) != 'object' || !('length' in list)) {
    return;
  }
  $('#searchFolderList input[type="checkbox"]').prop('checked', false);
  for(var i = 0; i < list.length; i++) {
    $('#searchFolderList input[value="' + list[i] + '"]').prop('checked', true);
  }
  $('#searchFolderList').show();
  $('#searchDefaultMailbox').hide();
  $('#setSearchDefaultMailbox').show();
}

function appendSearchResult(arr) {
  var curPos = parseInt($('#moreSearchResult').attr('data-value'));
  for(var i = 0; i < arr.length; i++) {
    var index = curPos + i;
    if($('#searchResultTable tr[data-value="' + index + '"]').length) {
      continue;
    }
    var msgHref = 'Hello.wssp?center=loadMessage&Mailbox=' +
      encodeURIComponent(arr[i].mailbox) + '&MSG=' + encodeURIComponent(arr[i].uid);
    var boxHref = 'Hello.wssp?center=loadMailbox&Mailbox=' + encodeURIComponent(arr[i].mailbox);
    var date = new Date(arr[i].Date) || '';
    if(date) {
      var day = prepZero(date.getUTCDate());
      var month = prepZero(date.getUTCMonth() + 1);
      var year = date.getUTCFullYear();
      var hh = prepZero(date.getUTCHours());
      var mm = prepZero(date.getUTCMinutes());
      var ss = prepZero(date.getUTCSeconds());
      date = day + '-' + month + '-' + year + ' ' + hh + ':' + mm + ':' + ss;
    }
    $('#searchResultTable').append(
      '<tr data-value="' + index + '">' +
        '<td width="20%"><a target="_blank" class="msgLink" href="' + msgHref + '">' +
        (arr[i].From || '') + '</a></td>' +
        '<td width="40%"><a target="_blank" class="msgLink" href="' + msgHref + '">' +
        (arr[i].Subject || '') + '</a></td>' +
        '<td width="15%"><a target="_blank" class="msgLink" href="' + msgHref + '">' +
        date + '</a></td>' +
        '<td width="25%"><a target="_blank" class="msgLink" href="' + boxHref + '">' +
        (arr[i].mailbox || '') + '</a></td>' +
      '</tr>'
    );
  }
}

function XIMSSController() {
  var that = this;
  var ximssSession = null;
  function loginCallback(newSession,errorCode) {
    if(errorCode != null) {
      that = null;
      return;
    }
    ximssSession = newSession;
    ximssSession.setUnknownAsyncProcessor(that,ximssAsyncProcessor);
    ximssSession.setNetworkErrorProcessor(that,ximssNetworkErrorProcessor);
    ximssSession.setAsyncProcessor(that,ximssEventReport,'taskEvent','eventName','reportSearchResult');
    ximssSession.setAsyncProcessor(that,ximssNotifyReport,'folderReport','mode','notify');
    ximssSession.start();
    findMeeting();
    subscribeInboxNotify();
  }
  function ximssNotifyReport() {
    that.sendRequest('folderSync', { folder: strings.sessionid + '-INBOX' });
  }
  function ximssEventReport(xmlResponse) {
    var curResult = $.parseJSON(xmlResponse.textContent);
    // display results
    if(curResult) {
      if(curResult.count) {
        var prevCount = parseInt($('#foundCounter').text());
        $('#foundCounter, #resFoundCounter').text(prevCount + curResult.count);
        if(curResult.count > 0) {
          $('#foundCounter').parent().addClass('active');
          if(prevCount == 0 && openResultFlag) {
            $('#foundCounter').parent().trigger('click');
          }
        }
        $('#moreSearchResult').show();
      }
      if(curResult.nextMailbox) {
        var maxLength = 16;
        var prefix = '...';
        var cut = curResult.nextMailbox;
        if(cut.length > maxLength) {
          cut = prefix + cut.substr(cut.length - (maxLength - prefix.length), maxLength - prefix.length);
        }
        $('#curSearchFolder, #resCurSearchFolder').text(cut);
        $('#curSearchFolder').parent().show();
        $('#resCurSearchFolder').parent().css('visibility', 'visible');
      }
      if(curResult.finished) {
        $('#stopSearch').hide();
        $('#curSearchFolder').parent().hide();
        $('#resCurSearchFolder').parent().css('visibility', 'hidden');
        $('#searchSettingsButton').show();
        $('#searchIndicator').hide();
        $('#resSearchIndicator').css('visibility', 'hidden');
        $('#searchButton').show();
        $('#searchField').removeAttr('disabled', 'disabled');
        $('#searchField').trigger('focusout');
      }
      if(curResult.data) {
        $('#searchQuery').text($('#searchField').val());
        appendSearchResult(curResult.data);
        var curPos = parseInt($('#moreSearchResult').attr('data-value'));
        if(curResult.bottom) {
          $('#moreSearchResult').hide();
          if(curResult.data.length >= searchResultLength) {
            curPos += searchResultLength;
            $('#moreSearchResult').attr('data-value', curPos);
          }
        } else {
          curPos += searchResultLength;
          $('#moreSearchResult').attr('data-value', curPos);
        }
      }
      if(curResult.query) {
        if(curResult.query.filter) {
          $('#searchField').val(curResult.query.filter);
          if(!curResult.finished) {
            $('#searchField').attr('disabled', 'disabled');
          }
          $('#searchField').trigger('focusout');
        }
      }
      if(curResult.sorted) {
        var num = $('#searchResultTable tr').length;
        $('#searchResultTable').html('');
        getSearchResult(0, num);
      }
      if(curResult.closed) {
        $('#stopSearch').hide();
        $('#curSearchFolder').parent().hide();
        $('#resCurSearchFolder').parent().css('visibility', 'hidden');
        $('#searchSettingsButton').show();
        $('#searchIndicator').hide();
        $('#resSearchIndicator').css('visibility', 'hidden');
        $('#searchButton').show();
        $('#foundCounter').parent().hide();
        $('#searchField').removeAttr('disabled', 'disabled');
        $('#searchField').val('');
        $('#searchField').trigger('focusout');
      }
    }
  }
  function ximssNetworkErrorProcessor(isFatal,timeElapsed) {
    if(isFatal) {
      // try to reconnect
      createSession(location.host, strings.userName, strings.sessionid);
    }
  }
  function ximssAsyncProcessor(xmlResponse) {
  }
  this.createSession = function(serverAddress,userName,password) {
    var params = new Object;
    params.binding = 'HTTP';
    if(location.protocol == 'https:') params.secureMode = 'YES';
    params.serverName = serverAddress;
    params.loginMethod = 'sessionid';
    params.sessionid = password;
    params.userName = userName;
    params.pollPeriod = 20;
    new XIMSSSession(params,this,loginCallback);
  }
  this.closeSession = function() {
    if(ximssSession != null) {
      ximssSession.close(that);
    }
  }
  this.sendRequest = function(request,params,data) {
    if(ximssSession == null) {
      return;
    }
    xmlRequest = ximssSession.createXMLNode(request);
    if(params != null) {
      for (var attr in params) {
        xmlRequest.setAttribute(attr,params[attr]);
      }
    }
    if(data != null) {
      if(typeof(data) == 'object') {
        if(request == 'prefsStore') {
          for(var prefName in data) {
            var pref = ximssSession.createXMLNode(prefName);
            pref = createXMLSubKeys(pref, data[prefName]);
            xmlRequest.appendChild(pref);
          }
        } else {
          xmlRequest = createXMLSubKeys(xmlRequest, data);
        }
      } else {
        if(request == 'taskStart') {
          var param = ximssSession.createXMLNode('param');
          param.appendChild(ximssSession.createTextNode(data));
          xmlRequest.appendChild(param);
        } else {
          xmlRequest.appendChild(ximssSession.createTextNode(data));
        }
      }
    }
    ximssSession.sendRequest(xmlRequest,that,dataCallback,finalCallback,true);
  }
  function finalCallback(errorCode,xmlRequest) {
  }
  function dataCallback(xmlData,xmlRequest) {
    if(xmlData.nodeName == 'taskCreated' || xmlData.nodeName == 'taskMeeting') {
      taskRef = xmlData.getAttribute('taskRef');
      if(taskRef) {
        // assume search in progress
        $('#searchSettingsButton').hide();
        $('#stopSearch').show();
        $('#searchButton').hide();
        $('#searchIndicator').show();
        $('#resSearchIndicator').css('visibility', 'visible');
        $('#foundCounter').parent().show();
        $('#foundCounter').text(0);
        $('#foundCounter').parent().removeClass('active');
        if(xmlData.nodeName == 'taskMeeting') {
          checkSearchStatus();
        } else {
          openResultFlag = true;
        }
      }
    } else if(xmlData.nodeName == 'prefs') {
      var nd = true;
      for(var i = 0; i < xmlData.childNodes.length; i++) {
        if(xmlData.childNodes[i].nodeName == 'MMSearchDefaultMailbox') {
          markDefaultMailbox(parseXMLObject(xmlData.childNodes[i]));
          nd = false;
          break;
        }
      }
      if(nd) {
        $('#searchFolderList').show();
        $('#searchDefaultMailbox').hide();
        $('#setSearchDefaultMailbox').show();
      }
    } else if(xmlData.nodeName == 'folderReport' && xmlData.getAttribute('mode') == 'added') {
      if(!(IE='\v'=='v')) {
        var notification = new Notification(
          "",
          {
            icon: strings.filesRef + 'compose_big.png',
            body: strings.newemail
          }
        );
      }
      playNotification();
      setTimeout(function() { location.reload(); }, 1500);
    }
  }
  function createXMLSubKeys(node, data) {
    if(typeof(data) == 'object') {
      if(Object.keys(data).length) {
        for (var key in data) {
          var element;
          if(isNaN(+key) || key == '' || !('length' in data)) {
            element = ximssSession.createXMLNode('subKey');
            element.setAttribute('key', key);
          } else {
            element = ximssSession.createXMLNode('subValue');
          }
          var value;
          if(typeof(data[key]) == 'object') {
            element = createXMLSubKeys(element, data[key]);
          } else {
            value = ximssSession.createTextNode(data[key]);
            element.appendChild(value);
          }
          if(data[key] != null || (typeof(data[key]) == 'object' && !Object.keys(data[key]).length)) {
            node.appendChild(element);
          }
        }
        if(!node.childNodes.length && !('length' in data)) {
          node.appendChild(ximssSession.createXMLNode('subKey'));
        }
      } else {
        if('length' in data) {
          node.appendChild(ximssSession.createXMLNode('subValue'));
        } else {
          node.appendChild(ximssSession.createXMLNode('subKey'));
        }
      }
    } else {
      node.appendChild(ximssSession.createTextNode(data));
    }
    return node;
  }
  function parseXMLObject(xml) {
    var result;
    var type;
    if(xml.nodeType == 1 || xml.nodeType == 9) {
      if(xml.childNodes.length) {
        if(xml.childNodes[0].nodeName == 'subKey') {
          // dict
          result = {};
          type = 'dict';
        } else if(xml.childNodes[0].nodeName == 'subValue') {
          // array
          result = [];
          type = 'array';
        } else {
          // other - assume we have only a text value
          return getXMLValue(xml.childNodes[0]);
        }
        for(var i = 0; i < xml.childNodes.length; i++) {
          if(xml.childNodes[i].nodeType == 1) {
            if(type == 'dict') {
              result[xml.childNodes[i].getAttribute('key')] = parseXMLObject(xml.childNodes[i]);
            } else if(type == 'array') {
              result.push(parseXMLObject(xml.childNodes[i]));
            }
          } else if(xml.childNodes[i].nodeType == 3) {
            if(type == 'dict') {
              result[xml.childNodes[i].getAttribute('key')] = getXMLValue(xml.childNodes[i]);
            } else if(type == 'array') {
              result.push(getXMLValue(xml.childNodes[i]));
            }
          }
        }
        return result;
      } else {
        return null;
      }
    } else if(xml.nodeType == 3) {
      // text
      return getXMLValue(xml);
    } else {
      return undefined;
    }
  }
  function getXMLValue(xml) {
    if(xml.textContent == '#NULL#') {
      return null;
    } else if(xml.textContent == 'YES') {
      return true;
    } else if(xml.textContent == 'NO') {
      return false;
    } else {
      return xml.textContent;
    }
  }
}

function createSession(serverAddress,userName,password) {
  if(controller != null) {
    controller = null;
  }
  controller = new XIMSSController();
  controller.createSession(serverAddress,userName,password);
}
function closeSession() {
  if(controller != null) {
    controller.sendRequest('folderClose', { folder: strings.sessionid + '-INBOX' });
    controller.closeSession();
  }
}
function findMeeting() {
  if(controller != null) {
    controller.sendRequest(
      'taskFindMeeting',
      {
        meetingSet: setName,
        meetingName: strings.sessionid,
      }
    );
  }
}
function startSearch(filter, filterField, mailbox, msgFields) {
  if(controller != null) {
    var param = {
      sessionid: strings.sessionid,
      setName: setName,
      query: {
        filter: filter,
        filterField: filterField,
        mailbox: mailbox,
      },
    };
    if(msgFields) {
      param.query.msgFields = msgFields;
    }
    controller.sendRequest(
      'taskStart',
      {
        programName: programName,
      },
      JSON.stringify(param)
    );
  }
}
function stopSearch() {
  if(controller != null && taskRef != null) {
    controller.sendRequest(
      'taskSendEvent',
      {
        eventName: 'stopSearch',
        taskRef: taskRef,
      }
    );
  }
}
function closeSearch() {
  if(controller != null && taskRef != null) {
    controller.sendRequest(
      'taskSendEvent',
      {
        eventName: 'closeSearch',
        taskRef: taskRef,
      }
    );
  }
}
function checkSearchStatus() {
  if(controller != null && taskRef != null) {
    controller.sendRequest(
      'taskSendEvent',
      {
        eventName: 'checkSearchStatus',
        taskRef: taskRef,
      }
    );
  }
}
function getSearchResult(start, length) {
  if(controller != null && taskRef != null) {
    controller.sendRequest(
      'taskSendEvent',
      {
        eventName: 'getSearchResult',
        taskRef: taskRef,
      },
      {
        start: start,
        length: length,
      }
    );
  }
}
function sortSearchResult(field, dir) {
  if(controller != null && taskRef != null) {
    controller.sendRequest(
      'taskSendEvent',
      {
        eventName: 'sortSearchResult',
        taskRef: taskRef,
      },
      {
        field: field,
        dir: dir,
      }
    );
  }
}
function getDefaultMailbox() {
  if(controller != null) {
    controller.sendRequest('prefsRead');
  }
}
function updateDefaultMailbox(list) {
  if(controller != null) {
    controller.sendRequest(
      'prefsStore',
      null,
      {
        MMSearchDefaultMailbox: list
      }
    );
  }
}
function subscribeInboxNotify() {
  if(controller != null) {
    controller.sendRequest('folderOpen',
      {
        folder: strings.sessionid + '-INBOX',
        mailbox: 'INBOX',
        sortField: 'INTERNALDATE'
      }
    );
    controller.sendRequest('folderSync', { folder: strings.sessionid + '-INBOX' });
    var audio = new Audio();
    audio.id = 'notify';
    //audio.src = strings.filesRef + notify;
    var src1 = document.createElement('source');
    src1.src = strings.filesRef + notify + '.ogg';
    src1.type = 'audio/ogg';
    audio.preload = 'auto';
    audio.appendChild(src1);
    var src2 = document.createElement('source');
    src2.src = strings.filesRef + notify + '.mp3';
    src2.type = 'audio/mpeg';
    audio.appendChild(src2);
    document.body.appendChild(audio);
    if(!(IE='\v'=='v')) {
      if(Notification.permission !== "granted") Notification.requestPermission();
    }
  }
}
function playNotification() {
  document.getElementById("notify").play();
}
