function sortTable(type, direction) {
	 var colNum;
	 var table = $('.contentBody > table').get(0);
        var tbody = $('.contentBody > table > tbody').get(0);

        var rowsArray = [];
        for(var i = 0; i<tbody.children.length; i++) {
          rowsArray.push(tbody.children[i]);
        }

        var compare;

        switch(type) {
          case 'size':
	    colNum = 1;
            compare = function(rowA, rowB) {
                if($(rowA).find('.sharedFolder').length || $(rowB).find('.sharedFolder').length || $(rowA).find('.sharedFile').length || $(rowB).find('.sharedFile').length) return -1;
		var a_str = rowA.cells[colNum].innerHTML.replace(/\s/g, '');
    a_str = a_str.replace(/(\d+)(.*)/, "$1 $2");
    var a = a_str.split(/\ /);
		var b_str = rowB.cells[colNum].innerHTML.replace(/\s/g, '');
    b_str = b_str.replace(/(\d+)(.*)/, "$1 $2");
    var b = b_str.split(/\ /);
		var a_size = a[0];
		var b_size = b[0];
		if(a_size == '') return 1;
		if(b_size == '') return -1;
		if(/K|k|К|к/.test(a[1])) a_size *= 1024;
		if(/M|m|М|м/.test(a[1])) a_size *= 1048576;
		if(/K|k|К|к/.test(b[1])) b_size *= 1024;
		if(/M|m|М|м/.test(b[1])) b_size *= 1048576;
		if(!direction) return a_size - b_size;
		else return b_size - a_size;
            };
            break;
          case 'name':
	    colNum = 0;
            compare = function(rowA, rowB) {
                if($(rowA).find('.sharedFolder').length || $(rowB).find('.sharedFolder').length || $(rowA).find('.sharedFile').length || $(rowB).find('.sharedFile').length) return -1;
		var a = rowA.cells[colNum].childNodes[3];
		if(a.getElementsByTagName('b').length) a = a.childNodes[0].innerHTML;
		else a = a.innerHTML;
		var b = rowB.cells[colNum].childNodes[3];
		if(b.getElementsByTagName('b').length) b = b.childNodes[0].innerHTML;
		else b = b.innerHTML;
              if(direction) return a.toLowerCase() > b.toLowerCase() ? 1 : -1;
		else return a.toLowerCase() > b.toLowerCase() ? -1 : 1;
            };
            break;
	   case 'type':
	     colNum = 0;
            compare = function(rowA, rowB) {
                if($(rowA).find('.sharedFolder').length || $(rowB).find('.sharedFolder').length || $(rowA).find('.sharedFile').length || $(rowB).find('.sharedFile').length) return -1;
		var a = rowA.cells[colNum].childNodes[3];
		if(a.getElementsByTagName('b').length) a = a.childNodes[0].innerHTML;
		else a = a.innerHTML;
		var b = rowB.cells[colNum].childNodes[3];
		if(b.getElementsByTagName('b').length) b = b.childNodes[0].innerHTML;
		else b = b.innerHTML;
		a = a.replace(/^.*\.(.+)$/, "$1");
		b = b.replace(/^.*\.(.+)$/, "$1");
              if(direction) return a.toLowerCase() > b.toLowerCase() ? 1 : -1;
		else return a.toLowerCase() > b.toLowerCase() ? -1 : 1;
            };
            break;
	   case 'date':
	     colNum = 3;
	     compare = function(rowA, rowB) {
               if($(rowA).find('.sharedFolder').length || $(rowB).find('.sharedFolder').length || $(rowA).find('.sharedFile').length || $(rowB).find('.sharedFile').length) return -1;
	       var a = new Date(rowA.cells[colNum].innerHTML);
	       var b = new Date(rowB.cells[colNum].innerHTML);
	       if(!direction) return a - b;
	       else return b - a;
	     };
	     break;
        }

        rowsArray.sort(compare);

        table.removeChild(tbody);

        while(tbody.firstChild) {
          tbody.removeChild(tbody.firstChild);
        }
 
        for(var i=0; i<rowsArray.length; i++) {
          tbody.appendChild(rowsArray[i]);
        }

        table.appendChild(tbody);

}

